ACM DP Monkey and Banana

2024-02-03 04:08
文章标签 dp acm monkey banana

本文主要是介绍ACM DP Monkey and Banana,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目:

A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food. 

The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height. 

They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn't be stacked. 

Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks. 
InputThe input file will contain one or more test cases. The first line of each test case contains an integer n, 
representing the number of different blocks in the following data set. The maximum value for n is 30. 
Each of the next n lines contains three integers representing the values xi, yi and zi. 
Input is terminated by a value of zero (0) for n. 
OutputFor each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format "Case case: maximum height = height". 
Sample Input
1
10 20 30
2
6 8 10
5 5 5
7
1 1 1
2 2 2
3 3 3
4 4 4
5 5 5
6 6 6
7 7 7
5
31 41 59
26 53 58
97 93 23
84 62 64
33 83 27
0
Sample Output
Case 1: maximum height = 40
Case 2: maximum height = 21
Case 3: maximum height = 28
Case 4: maximum height = 342


题意:

给出不同的长方体长宽高,上面的长方体的长宽必须严格小于下面的长宽,求出长方体塔的最大高度

分析:

类似于求最大上升子序列的问题,用dp[i]表示前i+1个长方体可以达到的最大高度,那么用第i+1个的长宽跟之前的所有的长宽都比较,如果可以,dp[i]=dp[j]+h[i];

代码:

#include<stdio.h>
#include<iostream>
#include<algorithm>
using namespace std;

struct Arc//由于每个长方体有6中形态,所以先用一个结构体存储,之后再加入到下面的结构体中

{

 int a[3];

}arc[32];
struct Arc_e//用来存储每个长方体的长宽高
{
    int l;
    int w;
    int h;
}arc_e[182];
int n,dp[182];
bool cmp(const Arc_e &a,const Arc_e &b)//按长宽分别为第一第二元素有小到大排序,优化节约时间
{
    if(a.l!=b.l) return a.l<b.l;
    else if(a.w!=b.w) return a.w<b.w;
    else return 0;
}
int solve()
{
    int res=0;
    for(int i=0;i<n*6;i++)
    {
        dp[i]=arc_e[i].h;
        for(int j=0;j<i;j++)
        {
            if((arc_e[i].l>arc_e[j].l)&&(arc_e[i].w>arc_e[j].w))
                dp[i]=max(dp[i],dp[j]+arc_e[i].h);
        }
        res=max(res,dp[i]);
    }
    return res;
}
int main()
{
    int casee=0;
   while(scanf("%d",&n)!=EOF)
   {
       if(n==0)
        break;
       for(int i=0;i<n;i++)
        scanf("%d %d %d",&arc[i].a[0],&arc[i].a[1],&arc[i].a[2]);
        int k=0;
       for(int j=0;j<n;j++)
       {
           Arc_e x1,x2,x3,x4,x5,x6;
           x1.l=arc[j].a[0];
           x1.w=arc[j].a[1];
           x1.h=arc[j].a[2];
           arc_e[k++]=x1;
           x2.l=arc[j].a[0];
           x2.w=arc[j].a[2];
           x2.h=arc[j].a[1];
           arc_e[k++]=x2;
           x3.l=arc[j].a[1];
           x3.w=arc[j].a[0];
           x3.h=arc[j].a[2];
           arc_e[k++]=x3;
           x4.l=arc[j].a[1];
           x4.w=arc[j].a[2];
           x4.h=arc[j].a[0];
           arc_e[k++]=x4;
           x5.l=arc[j].a[2];
           x5.w=arc[j].a[1];
           x5.h=arc[j].a[0];
           arc_e[k++]=x5;
           x6.l=arc[j].a[2];
           x6.w=arc[j].a[0];
           x6.h=arc[j].a[1];
           arc_e[k++]=x6;
       }
       sort(arc_e,arc_e+n*6,cmp);
       printf("Case %d: maximum height = %d\n",++casee,solve());
   }
   return 0;
}

这篇关于ACM DP Monkey and Banana的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/672939

相关文章

认识、理解、分类——acm之搜索

普通搜索方法有两种:1、广度优先搜索;2、深度优先搜索; 更多搜索方法: 3、双向广度优先搜索; 4、启发式搜索(包括A*算法等); 搜索通常会用到的知识点:状态压缩(位压缩,利用hash思想压缩)。

hdu4826(三维DP)

这是一个百度之星的资格赛第四题 题目链接:http://acm.hdu.edu.cn/contests/contest_showproblem.php?pid=1004&cid=500 题意:从左上角的点到右上角的点,每个点只能走一遍,走的方向有三个:向上,向下,向右,求最大值。 咋一看像搜索题,先暴搜,TLE,然后剪枝,还是TLE.然后我就改方法,用DP来做,这题和普通dp相比,多个个向上

hdu1011(背包树形DP)

没有完全理解这题, m个人,攻打一个map,map的入口是1,在攻打某个结点之前要先攻打其他一个结点 dp[i][j]表示m个人攻打以第i个结点为根节点的子树得到的最优解 状态转移dp[i][ j ] = max(dp[i][j], dp[i][k]+dp[t][j-k]),其中t是i结点的子节点 代码如下: #include<iostream>#include<algorithm

hdu4865(概率DP)

题意:已知前一天和今天的天气概率,某天的天气概率和叶子的潮湿程度的概率,n天叶子的湿度,求n天最有可能的天气情况。 思路:概率DP,dp[i][j]表示第i天天气为j的概率,状态转移如下:dp[i][j] = max(dp[i][j, dp[i-1][k]*table2[k][j]*table1[j][col] )  代码如下: #include <stdio.h>#include

usaco 1.1 Broken Necklace(DP)

直接上代码 接触的第一道dp ps.大概的思路就是 先从左往右用一个数组在每个点记下蓝或黑的个数 再从右到左算一遍 最后取出最大的即可 核心语句在于: 如果 str[i] = 'r'  ,   rl[i]=rl[i-1]+1, bl[i]=0 如果 str[i] = 'b' ,  bl[i]=bl[i-1]+1, rl[i]=0 如果 str[i] = 'w',  bl[i]=b

uva 10154 DP 叠乌龟

题意: 给你几只乌龟,每只乌龟有自身的重量和力量。 每只乌龟的力量可以承受自身体重和在其上的几只乌龟的体重和内。 问最多能叠放几只乌龟。 解析: 先将乌龟按力量从小到大排列。 然后dp的时候从前往后叠,状态转移方程: dp[i][j] = dp[i - 1][j];if (dp[i - 1][j - 1] != inf && dp[i - 1][j - 1] <= t[i]

uva 10118 dP

题意: 给4列篮子,每次从某一列开始无放回拿蜡烛放入篮子里,并且篮子最多只能放5支蜡烛,数字代表蜡烛的颜色。 当拿出当前颜色的蜡烛在篮子里存在时,猪脚可以把蜡烛带回家。 问最多拿多少只蜡烛。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cs

uva 10069 DP + 大数加法

代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#include <stack>#include <vector>#include <queue>#include <map>#include <cl

uva 10029 HASH + DP

题意: 给一个字典,里面有好多单词。单词可以由增加、删除、变换,变成另一个单词,问能变换的最长单词长度。 解析: HASH+dp 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#inc

XTU 1233 n个硬币连续m个正面个数(dp)

题面: Coins Problem Description: Duoxida buys a bottle of MaiDong from a vending machine and the machine give her n coins back. She places them in a line randomly showing head face or tail face o